﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;

namespace WebApplication1
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadData();
            }
            else
            {
                DataSet ds = ViewState["DataSet"] as DataSet;

                AuditDataWebGrid.DataSource = ds;
                AuditDataWebGrid.DataBind();
            }
        }

        private void LoadData()
        {
            DataSet ds = null;
            if (DataSourceDropDown.SelectedIndex > 0)
            {
                ds = new DataSet();
                DataTable table = new DataTable();
                table.TableName = (DataSourceDropDown.SelectedIndex == 1) ? "Customers" : "Employees";

                // Create two columns, ID and Name.
                DataColumn idColumn = (DataSourceDropDown.SelectedIndex == 1) ? table.Columns.Add("ID", typeof(int)) : table.Columns.Add("ID2", typeof(int));
                if (DataSourceDropDown.SelectedIndex == 1)
                {
                    table.Columns.Add("Name", typeof(string));
                }
                else
                {
                    table.Columns.Add("Name2", typeof(string));
                }

                // Set the ID column as the primary key column.
                table.PrimaryKey = new DataColumn[] { idColumn };

                for (int i = 0; i < 30; i++)
                {
                    if (DataSourceDropDown.SelectedIndex == 1)
                    {
                        table.Rows.Add(new object[] { i, "Customer " + i });
                    }
                    else
                    {
                        table.Rows.Add(new object[] { i, "Employee " + i });
                    }
                }
                table.AcceptChanges();
                ds.Tables.Add(table);
                ViewState.Add("DataSet", ds);
            }
            PopulateGrid(ds);
        }

        protected void UpdateButton_OnClick(object sender, EventArgs e)
        {
        }

        private void PopulateGrid(DataSet ds)
        {
            AuditDataWebGrid.DataSource = ds;
            AuditDataWebGrid.DataBind();
        }

        protected void AuditDataWebGrid_ColumnSorted(object sender, SortingEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).Sort(e);
        }

        protected void AuditDataWebGrid_DataFiltering(object sender, FilteringEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).Filter(e);
            e.Cancel = true;
        }

        protected void AuditDataWebGrid_ColumnMoved(object sender, ColumnMovingEventArgs e)
        {
            //((IDataGridPresenter)PresenterController).ColumnMoving(e);
        }

        protected void AuditDataWebGrid_InitializeRow(object sender, RowEventArgs e)
        {
            //((IAuditTablePresenter)PresenterController).FormatRow(e);
        }

        protected void DataSourceDropDown_SelectedIndexChanged(object sender, EventArgs e)
        {
            AuditDataWebGrid.ClearDataSource();
            AuditDataWebGrid.Behaviors.Filtering.ClearBehaviorColumnInfo();
            AuditDataWebGrid.Behaviors.Sorting.SortedColumns.Clear();
            LoadData(); 
        }
    }
}
